package org.tbasket.test.pages

import io.getquill.NamingStrategy
import io.getquill.context.qzio.ZioJdbcContext
import io.getquill.context.sql.idiom.SqlIdiom
import org.tbasket.auth.Authenticator
import org.tbasket.data.DatabaseContext
import org.tbasket.dispatch.StaticWebService
import org.tbasket.handler.LoginPageHandler.post
import org.tbasket.test.TestLayers.*
import zio.*
import zio.http.netty.client.ConnectionPool
import zio.http.{Client, ClientConfig, URL}
import zio.test.{Spec, TestEnvironment, ZIOSpecDefault}

import javax.sql.DataSource

abstract class TBasketPageSpec(location: String) extends ZIOSpecDefault {
  
  protected val url = URL.fromString(s"http://localhost$location") match
    case Left(value) => throw value
    case Right(url)  => url
  
  protected def tspec: Spec[DataSource & ClientConfig & Authenticator & ConnectionPool & Scope & DatabaseContext & Client & StaticWebService, Any]
  
  final override def spec = tspec.provide(
    db.datasourceLayer,
    db.contextLayer,
    auth,
    resp,
    ConnectionPool.fixed(1),
    Scope.default,
    ClientConfig.default,
    Client.live)
}
